#/bin/bash
#
# All Rights Reserved, Copyright (c) FUJITSU LIMITED 2012-2017
#
#	Configuration Tool for Oracle VM Server for SPARC
#
# Revision 3.0  2017/11/23
#
# pattern2_primary.sh

primary_pattern2()
{
DOMAIN=primary

#---set default------------------------------------------------------------#
CPU_MIN=1
CPU_DEF=2
MEM_MIN=4096
MEM_DEF=4096

STPORT="5000"
EDPORT="5100"
#VDS="primary-vds0"
CONFIG=config_initial
#--------------------------------------------------------------------------#
TITLE=" 1.Configure a Primary Domain"
DKIND="primary"
PATTERN="Pattern 2"
work_out="${work_dir}"

############################################################################
# Assign CPU
############################################################################
#	echo "CPU    : $CPU disabled" >> $work_out/cpu.tmp

header "$TITLE" "$PATTERN"
print_cpu
print "# CPU cores                                                                      [1/9]"
print ""
print "Assign CPU cores to the primary domain."
print ""
cat $work_dir/cpulist.tmp
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

domain_cpu 1

if [ -f $work_out/cpu.info ];then
        echo "=== The following quantity of CPU cores will be allocated ==="
        cat $work_out/cpu.info
else
        echo ""
        echo "CPU core will not be allocated."
fi
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Setting Memory
############################################################################
#	echo "Memory : $MEM MB for the primary domain $DOMAIN" >> $work_out/mem.tmp

header "$TITLE" "$PATTERN"
print_memory
print "# Memory                                                                         [2/9]"
print ""
print "Assign memory to the primary domain."
print ""
cat $work_dir/memlist.tmp
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

domain_memory

echo "=== The following memory will be allocated ==="
cat $work_out/mem.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Creating FiberChannel VF (SR-IOV)  # V3.0
############################################################################

header "$TITLE" "$PATTERN"
print "# FiberChannel VF (SR-IOV)                                                       [3/9]"
print ""
print "Do you wish to create a VF (SR-IOV) to use virtual FiberChannel devices in I/O domains?"
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

while :
do
        YNf=""
        echo "Create a FibreChannel VF devices? ([y]/n) ==> \c"
        read YNf
        case ${YNf:-y} in
                 [t])   top
                        ;;
                  [q])  quit
                        ;;
                  [y])  break
                        ;;
                  [n])  break
                        ;;
                    *)  continue
                        ;;
        esac
done

NUM_of_FCPF=0
NUM_of_FCVF=0

if [ ${YNf:-y} = y ];then
        print_fcpf
        if [ ${NUM_of_FCPF} -gt 0 ];then
        create_fcvf
        fi
fi

if [ ${YNf:-y} = n -o ${NUM_of_FCVF} -eq 0 ];then
        echo ""
        echo "Fiber Channel VF device will not be created."
else
        echo ""
        echo "=== These Fibre Channel VF device will be created ==="
        cat $work_out/fcvf.tmp
fi


echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Creating Network VF (SR-IOV) # V3.0
############################################################################

header "$TITLE" "$PATTERN"
print "# Network VF (SR-IOV)                                                            [4/9]"
print ""
print "Do you wish to create a VF (SR-IOV) to use virtual Network devices in I/O domains?"
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

while :
do
        YNn=""
        echo "Create a Network VF devices? ([y]/n) ==> \c"
        read YNn
        case ${YNn:-y} in
                 [t])   top
                        ;;
                  [q])  quit
                        ;;
                  [y])  break
                        ;;
                  [n])  break
                        ;;
                    *)  continue
                        ;;
        esac
done

NUM_of_NICPF=0
NUM_of_NICVF=0

if [ ${YNn:-y} = y ];then
        print_nicpf

        if [ ${NUM_of_NICPF} -gt 0 ];then
        create_nicvf
        fi
fi

if [ ${YNn:-y} = n -o ${NUM_of_NICVF} -eq 0 ];then
        echo ""
        echo "Network VF device will not be created."
else
        echo ""
        echo "=== These Network VF device will be created ==="
        cat $work_out/nicvf.tmp
fi

echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key


############################################################################
# Setting VCC
############################################################################

echo "VCC    : primary-vcc0 will use the port range of $STPORT to $EDPORT" >> $work_out/vcc.tmp

############################################################################
# Setting VDS
############################################################################
# 
#echo "VDS    : Add $VDS to the $DOMAIN domain." >> $work_out/vds.tmp

############################################################################
# Check configuration file name
############################################################################

header "$TITLE" "$PATTERN"
CONF_O=$CONFIG
config_name $CONF_O

echo ""
echo "=== The configuration will be saved as the following ==="
echo "The configuration name : $CONFIG" | tee -a $work_out/config.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Confirming configuration
############################################################################

header "$TITLE" "$PATTERN"
print "The following primary domain configuration will be set."
print ""
print "======= Your configuration information for primary domain ============================="
printf "Domain : %s\n" "$DOMAIN"
cat $work_out/cpu.info
cat $work_out/mem.tmp
#printf "CPU    : %s cores for the primary domain\n" "$CPU"
#printf "Memory : %s MB for the primary domain\n" "$MEM"
print "-------------------------------------------------------------------"
cat $work_out/vcc.tmp
cat $work_out/fcvf.tmp
cat $work_out/nicvf.tmp
print "-------------------------------------------------------------------"
cat $work_out/config.tmp
print "======================================================================================="
print ""

############################################################################
# Execution and creating of configuration file
############################################################################

EXE=$conf_dir/${DOMAIN}-${DATE}.sh

save_exec 0

############################################################################
# Delete temporary file 
############################################################################

delete
############################################################################

}
