#/bin/bash
#
# All Rights Reserved, Copyright (c) FUJITSU LIMITED 2012-2017
#
#	Configuration Tool for Oracle VM Server for SPARC
#
# Revision 3.0  2017/11/26
#
# pattern3_primary.sh

primary_pattern3()
{
DOMAIN=primary

#---set default------------------------------------------------------------#
#CPU=4
CPU_MIN=1
CPU_DEF=2
#MEM=16384
MEM_MIN=4096
MEM_DEF=4096
STPORT="5000"
EDPORT="5100"
CONFIG=config_initial
#PRIIO="pci@8000 pci@8100"
#MEM_PA="0x7e"
#if [ "$MODEL" = "T4-2" -o "$MODEL" = "T4-4" ];then
#	PRIIO="pci@400"
#	MEM_PA="0x20"
#fi
#--------------------------------------------------------------------------#
#CPU_SOCKET=0
#LDM_DEF=3.4
#LDM_VER=`pkg info ldomsmanager|grep FMRI|awk -F"@" '{print $2}'|cut -c-3`
#SOCKET_FLG=`echo "$LDM_VER - $LDM_DEF" | bc | cut -c 1`
#--------------------------------------------------------------------------#
TITLE=" 1.Configure a Primary Domain"
DKIND="primary"
PATTERN="Pattern 3"
work_out="${work_dir}"
############################################################################
# Confirm removed I/O devices
############################################################################

status=`print_io`

#--------------------------------------------------------------------------#

header "$TITLE" "$PATTERN"
print "# Select I/O to exclude                                                          [1/4]"
print ""
print "Remove some I/O devices from the primary domain."
print "Please select I/O devices from the primary domain."
print ""
print "### Allocation status of the current I/O devices ###"
print ""
print_io | tee -a $work_dir/iolist.tmp
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

        COUNT1=0
        COUNT2=`cat $work_dir/iolist.tmp |grep BUS | wc -l`
        echo ""

        while [ $COUNT1 -lt $COUNT2 ]
        do
                A=(`cat $work_dir/iolist.tmp | sed -n '/^ '$COUNT1'/p' | awk '{print $2,$4,$5}'`)
                if [ "${A[1]}" = "primary" ];then
                        YN=""
                        echo "Remove I/O device No. "$COUNT1" ? (y/[n]) ==> \c"
                        read YN
                        case ${YN:-n} in
                                  [t])  top
                                        continue
                                        ;;
                                  [q])  quit
                                        continue
                                        ;;
                                  [y])  if [ "${A[2]}" = "[boot-device]" ];then
                                                YN=""
                                                echo "No. "$COUNT1" device is a primary domain boot device. Are you sure ? (y/[n]) ==> \c"
                                                read YN
                                                case ${YN:-n} in
                                                  [t])  top
                                                        continue
                                                        ;;
                                                  [q])  quit
                                                        continue
                                                        ;;
                                                  [y])  echo "I/O    : ${A[0]} remove from ${A[1]} domain." >> $work_out/remove_io.tmp
                                                        ;;
                                                  [n])  continue
                                                        ;;
                                                    *)  continue
                                                        ;;
                                                esac
                                        else
                                                echo "I/O    : ${A[0]} remove from ${A[1]} domain." >> $work_out/remove_io.tmp
                                        fi
                                        ;;
                                  [n])
                                        ;;
                                    *)  continue
                                        ;;
                        esac
                else
                        echo "The No. "$COUNT1" device has already been removed or allocated to another domain."
                        echo "Please press the enter key. \c"
                        read
                fi

                COUNT1=`expr $COUNT1 + 1`

                if [ -f $work_out/remove_io.tmp ];then
                        COUNT3=`cat $work_out/remove_io.tmp | wc -l`
                        COUNT4=`cat $work_dir/iolist.tmp | grep primary | wc -l`
                        if [ $COUNT3 -eq $COUNT4 ];then
                                echo ""
                                echo "---------------------------------------------------------------------------------------"
                                echo "Cannot remove all I/O devices from the primary domain."
                                echo "Please select again."
                                echo "---------------------------------------------------------------------------------------"
                                echo ""
                                COUNT1=0
                                rm $work_out/remove_io.tmp
                        fi
                fi
        done

        if [ -f $work_out/remove_io.tmp ];then
                echo ""
                echo "=== Confirm removed I/O devices ==="
                cat $work_out/remove_io.tmp
        else
                echo ""
                echo "I/O devices were not removed."
        fi

echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Creating VSW
############################################################################

header "$TITLE" "$PATTERN"
print "# Create a Virtual switch                                                        [2/4]"
print ""
print "Do you wish to create the virtual switch service (vsw) to connect logical domains by"
print "the virtual network (vnet)?"
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

while :
do
	YN=""
	echo "Create a virtual switch service? ([y]/n) ==> \c"
	read YN
	case ${YN:-y} in
		[t])	top
			;;
		[q])	quit
			;;
		[y])	break
			;;
		[n])	break
			;;
		  *)	continue
			;;
	esac
done

if [ "${YN:-y}" != n ];then
	echo ""
	echo "=== Set the virtual switch service configuration ==="
	add_vsw 0
	if [ -f $work_dir/vsw.tmp ];then
		echo ""
		echo "=== These virtual switch service settings will be created ==="
		cat $work_dir/vsw.info
	else
		echo ""
		echo "A virtual switch service will not be created."
	fi
else
	echo ""
	echo "A virtual switch service will not be created."
	echo "VSW    : A virtual switch service will not be created." >> $work_dir/vsw.info
fi
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Assign CPU
############################################################################

header "$TITLE" "$PATTERN"
print_cpu
print "# CPU cores                                                                      [3/4]"
print ""
print "Assign CPU cores to the primary domain."
print ""
cat $work_dir/cpulist.tmp
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

domain_cpu 1

if [ -f $work_out/cpu.info ];then
        echo "=== The following quantity of CPU cores will be allocated ==="
        cat $work_out/cpu.info
else
        echo ""
        echo "CPU core will not be allocated."
fi
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key
	
############################################################################
# Setting Memory
############################################################################

header "$TITLE" "$PATTERN"
print_memory
print "# Memory                                                                         [4/4]"
print ""
print "Assign memory to the primary domain."
print ""
cat $work_dir/memlist.tmp
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

domain_memory

echo "=== The following memory will be allocated ==="
cat $work_out/mem.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key


############################################################################
# Setting VCC
############################################################################

echo "VCC    : primary-vcc0 will use the port range of $STPORT to $EDPORT" >> $work_out/vcc.tmp

############################################################################
# Check configuration file name
############################################################################

header "$TITLE" "$PATTERN"
CONF_O=$CONFIG
config_name $CONF_O

echo ""
echo "=== The configuration will be saved as the following ==="
echo "The configuration name : $CONFIG" | tee -a $work_out/config.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Confirm the domain configuration
############################################################################

header "$TITLE" "$PATTERN"
print "The following primary domain configuration will be set."
print ""
print "======= Your configuration information for primary domain ============================="
cat $work_out/cpu.info
cat $work_out/mem.tmp
print "-------------------------------------------------------------------"
cat $work_out/vcc.tmp
cat $work_out/vsw.info
print "-------------------------------------------------------------------"
cat $work_dir/remove_io.tmp
print "-------------------------------------------------------------------"
print "The configuration name : $CONFIG"
print "======================================================================================="
print ""

############################################################################
# Execution and creating of configuration file
############################################################################

EXE=$conf_dir/${DOMAIN}-${DATE}.sh

save_exec 0

############################################################################
# Delete temporary file 
############################################################################

delete
############################################################################

}
